=== debian/changelog ===
ocaml (4.11.1-4) unstable; urgency=medium

  [ Pino Toscano ]
  * Make sure ocaml pulls ocaml-nox as well. (Closes: #973039)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 30 Oct 2020 08:38:03 +0100

ocaml (4.11.1-3) unstable; urgency=medium

  * Upload to unstable
  * Disable some tests that fail on Hurd

 -- Stéphane Glondu <glondu@debian.org>  Mon, 12 Oct 2020 16:56:34 +0200

ocaml (4.11.1-2) experimental; urgency=medium

  * Call ./configure with --disable-native-compiler on all bytecode
    architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 04 Sep 2020 15:31:40 +0200

ocaml (4.11.1-1) experimental; urgency=medium

  * New upstream release
    - Add riscv64 to native-archs
    - Trigger -output-complete-exe on -custom with an environment variable
      (OCAML_CUSTOM_USE_OUTPUT_COMPLETE_EXE)
    - Re-enable testpreempt test
    - Re-enable most of tool-debugger tests

 -- Stéphane Glondu <glondu@debian.org>  Fri, 04 Sep 2020 08:33:22 +0200

ocaml (4.08.1-10) unstable; urgency=medium

  * Disable DT_TEXTREL warnings on i386
  * Unconditionally disable testpreempt test

 -- Stéphane Glondu <glondu@debian.org>  Thu, 30 Jul 2020 14:45:47 +0200

ocaml (4.08.1-9) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Fix FTBFS with gcc-10 (Closes: #957623)
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0

  [ Ralf Treinen ]
  * Replace suggestion of tuareg-mode, which is now a transitional package,
    by elpa-tuareg.

 -- Stéphane Glondu <glondu@debian.org>  Fri, 24 Jul 2020 16:51:04 +0200
